package project5

import util._

/**
 * First Part
 */

object Streams {

  /**
   * Functions from the course that are useful for Exercise 1
   */

  def partialSums(s: Stream[Double]): Stream[Double] =
    Stream.cons(s.head, partialSums(s.tail) map { _ + s.head })


  def eulerTransform(s: Stream[Double]): Stream[Double] = {
    val s0 = s apply 0
    val s1 = s apply 1
    val s2 = s apply 2
    Stream.cons(s2 - ((s2 - s1) * (s2 - s1)) / (s0 - 2*s1 + s2), eulerTransform(s.tail))
  }

  def tableau(transform: Stream[Double] => Stream[Double], s: Stream[Double]): Stream[Stream[Double]] =
    Stream.cons(s, tableau(transform, transform(s)))


  /**
   * Exercise 1
   */

  def ln2Summands(n: Int): Stream[Double] = ???

  def ln2: Stream[Double] = ???

  def ln2Euler: Stream[Double] = ???

  def ln2Tableau: Stream[Double] = ???


  /**
   * Exercise 2
   */

  def fromTo(lower: Int, upper: Int): Stream[Int] = ???

  def intPairs: Stream[(Int, Int)] = ???

  def intPairs2: Stream[(Int, Int)] = ???


  /**
   * Exercise 3
   */

  def countStream(s: Stream[Int]): Stream[Int] = ???

  def allCountStreams: Stream[Stream[Int]] = ???


  /**
   * You can use the main method for testing. However, we encourage you to
   * also have a look at the test file "src/test/scala/StreamsSuite.scala"
   * and write more unit such as the ones given.
   */
  def main(args: Array[String]) {
    print("ln2 = "); ln2.take(10).print
    println()

    println("count streams")
    allCountStreams.take(5).map(_.mkString("-")).print
  }
}
