package project5

import org.scalatest.FunSuite
import org.junit.runner.RunWith
import org.scalatest.junit.JUnitRunner

@RunWith(classOf[JUnitRunner])
class ConstraintSuite extends FunSuite {
  test("Adder") {
    val q1, q2 = new Quantity
    val q3 = q1 + q2
    q1.setValue(20)
    q3.setValue(22)
    assert(q2.getValue === Some(2.0))

    q1.forgetValue
    assert(q2.getValue === None)
  }
  
  // Add more tests
}
